//
//  ANTextDrawingHelper.h
//  AvisNocturnaCrossCore
//
//  Created by Mendel Kucharzeck on 19.12.11.
//  Copyright 2011 AvisNocturna Software. All rights reserved.
//

enum _TextDrawingHelperAlignment
{
	TextDrawingHelperAlignment_Left = 0,
	TextDrawingHelperAlignment_Center = 2,
	TextDrawingHelperAlignment_Right = 1
	
}typedef TextDrawingHelperAlignment;

enum _TextDrawingHelperWordWrap
{
	TextDrawingHelperWordWrap_Word = 0,
	TextDrawingHelperWordWrap_Character = 1,
	TextDrawingHelperWordWrap_Clip = 2,
	TextDrawingHelperWordWrap_Head = 3,
	TextDrawingHelperWordWrap_Tail = 4,
	TextDrawingHelperWordWrap_Middle = 5
	
}typedef TextDrawingHelperWordWrap;

@interface ANTextDrawingHelper : NSObject

+ (void) drawString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font;
+ (void) drawString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment;
+ (void) drawString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap;
+ (void) drawString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withPlattformColor:(id)color withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap;

+ (CGSize) sizeOfString:(NSString*)string withPlattformFont:(id)font;
+ (CGSize) sizeOfString:(NSString*)string withPlattformFont:(id)font constrainedToSize:(CGSize)constrain;

//Emboss
+ (void) drawBlackEmbossedString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap;
+ (void) drawBlackEmbossedString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap withEmbossStrength:(float)embossStrength;
+ (void) drawBlackEmbossedString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap withEmbossStrength:(float)embossStrength withOpacity:(float)opacity;

+ (void) drawWhiteEmbossedString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap;
+ (void) drawWhiteEmbossedString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap withEmbossStrength:(float)embossStrength;
+ (void) drawWhiteEmbossedString:(NSString*)string inRect:(CGRect)rect withPlattformFont:(id)font withAlignment:(TextDrawingHelperAlignment)alignment withWordWrap:(TextDrawingHelperWordWrap)wordWrap withEmbossStrength:(float)embossStrength withOpacity:(float)opacity;

@end
